<?php
/**
 * The plugin bootstrap file
 *
 * This file is read by WordPress to generate the plugin information in the
 * plugin admin area. This file also defines a function that starts the plugin.
 *
 * @link              https://radiowombat.net
 * @since             1.0.0
 * @package           Radio Wombat Toolkit Plugin
 *
 * @wordpress-plugin
 * Plugin Name:       Radio Wombat Toolkit
 * Plugin URI:        https://radiowombat.net
 * Description:       Gestione del palinsesto, versione wombat friendly
 * Version:           1.0.3
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 */

if (! defined('WPINC')) {
    die;
}

date_default_timezone_set("Europe/Rome");

register_activation_hook(__FILE__, 'add_broadcast_taxonomy');
function add_broadcast_taxonomy($args)
{
    $check = term_exists('trasmissioni', 'category', 0);
    if (!$check) {
        $args = array(
            'parent' => 0,
            'slug' => 'trasmissioni'
        );
        wp_insert_term('Trasmissioni', 'category', $args);
    }
}

foreach (glob(plugin_dir_path(__FILE__) . 'admin/*.php') as $file) {
    include_once $file;
}

foreach (glob(plugin_dir_path(__FILE__) . 'inc/*.php') as $file) {
    include_once $file;
}

foreach (glob(plugin_dir_path(__FILE__) . 'shortcodes/*.php') as $file) {
    include_once $file;
}
